#!/usr/bin/env python
# -*- coding: utf-8 -*- 
#

import sys
import string
from omniORB import CORBA
from xml.dom.minidom import parse

import dtdValidator

#
# 
#
class RtmParser :
#  def serializeDOM(self, target, node) :

# XMLեν: DOMĥ꡼  XML
  def dump2file(self, outfilename=None) :
    if outfilename:
      self.outfilename = outfilename
    if self.outfilename :
      print "outfilename:",self.outfilename
      self.outfile = open(self.outfilename, "w")
      self.outfile.write(self.cur_node.toxml())
      self.outfile.write("\n")
      self.outfile.close()
    else :
      none
    return 1

  def dump2cout(self) :
    print(self.cur_node.toxml())
    return 1

# root node μ
  def get_root(self) :
    return self.the_root_node

  def get_cur_node(self) :
    return self.cur_node

  def set_cur_node(self, nd) :
    self.cur_node = nd
    return 1

  def reset_node(self) :
    self.cur_node = self.the_root_node
    return 1

  def getChildNodes(self) :
    self.node_list = self.cur_node.childNodes
    return self.node_list

  def getTaggedNodes(self, tg) :
    self.node_list = self.cur_node.getElementsByTagName(tg)
    return self.node_list

  def getText(self, nodes=None) :
    if nodes == None:
      nodes = self.cur_node.childNodes
    rc = ''
    for node in nodes:
      if node.nodeType == node.TEXT_NODE:
        rc = rc + node.data
    return rc

  def replaceText(self, txt) :
    tmp_node = self.dom.createTextNode(txt)
    self.cur_node.childNodes = [tmp_node]
    return 1

  def getTaggedText(self, tg) :
    nodes = self.cur_node.getElementsByTagName(tg)[0]
#    tmp_root = nodes[0]
#    nodes = tmp_root.childNodes
    rc = self.getText(nodes.childNodes)
    return rc
  
# child element ι(replace)
  def replaceTaggedText(self, tg, txt) :
    nodes = self.cur_node.getElementsByTagName(tg)
    tmp_root = nodes[0]
    tmp_node = self.dom.createTextNode(txt)
    tmp_root.childNodes = [tmp_node]
    return 1

# child node κ(remove)
  def removeChildNode(self, nd):
    self.cur_node.removeChild(nd)

# element,text ҥΡɤȤɲ
  def appendChildTaggedText(self, tg, txt):
    tmp_elem = self.dom.createElement(tg)
    tmp_txt = self.dom.createTextNode(txt)
    tmp_elem.appendChild(tmp_txt)
    self.cur_node.appendChild(tmp_elem)
    return tmp_elem
    
# elementҥΡɤȤɲ
  def appendChildTagged(self, tg):
    tmp_elem = self.dom.createElement(tg)
    self.cur_node.appendChild(tmp_elem)
    return tmp_elem

#
# for C access
#
  def set_tmplist(self, lst) :
    self.tmp_node_list = lst
    return 1

  def elt_tmp(self, idx) :
    return self.tmp_node_list[idx];
#
# for C access (end)
#

  def getComponentNode(self, comp_key):
    # search for compornent node list
    comp_list = self.the_root_node.getElementsByTagName("rt_component")
    tmp = ''
    tmp1 = ''
    tmp2 = ''
    tmp3 = ''
    tmp4 = ''
    tmp5 = ''
    ret = None
    for comp_node in comp_list:

      tmp1 = comp_node.getElementsByTagName("host_name")[0]
      tmp1 = self.getText(tmp.childNodes)
      tmp2 = comp_node.getElementsByTagName("manager_name")[0]
      tmp2 = self.getText(tmp.childNodes)
      tmp3 = comp_node.getElementsByTagName("category")[0]
      tmp3 = self.getText(tmp.childNodes)
      tmp4 = comp_node.getElementsByTagName("module_name")[0]
      tmp4 = self.getText(tmp.childNodes)
      tmp5 = comp_node.getElementsByTagName("component_name")[0]
      tmp5 = self.getText(tmp.childNodes)

      tmp = tmp1 + "/" + tmp2 + "/" + tmp3 + "/" + tmp4 + "/" + tmp5

      if tmp == comp_key:
        break

    if tmp1 == '' or tmp2 == '' or tmp3 == '' or tmp4 == '' or tmp5 == '':
#       tmp1 == '.*' or tmp2 == '.*' or tmp3 == '.*' or tmp4 == '.*' or tmp5 == '.*' :
      print "Component Name is not an"
      print self.infilename
    else:
      self.cur_node = comp_node
      ret = self.cur_node
    return ret

  def getComponentNames(self):
    # search for compornent node list
    comp_list = self.the_root_node.getElementsByTagName("rt_component")
    ret = []
    save_node = self.get_cur_node()
    for comp_node in comp_list:
      self.set_cur_node(comp_node)
      tmp = self.getTaggedText("component_name")
      ret.append(tmp)
    self.set_cur_node(save_node)
    return ret

  def getComponentKeys(self):
    # search for compornent node list
    comp_list = self.the_root_node.getElementsByTagName("rt_component")
    ret = []
    save_node = self.get_cur_node()
    for comp_node in comp_list:
      self.set_cur_node(comp_node)
      tmp = self.getTaggedText("component_name")

      tmp1 = self.getTaggedText("host_name")
      tmp2 = self.getTaggedText("manager_name")
      tmp3 = self.getTaggedText("category")
      tmp4 = self.getTaggedText("module_name")
      tmp5 = self.getTaggedText("component_name")
      nam = tmp1 + "/" + tmp2 + "/" + tmp3 + "/" + tmp4 + "/" + tmp5

      ret.append(nam)
    self.set_cur_node(save_node)
    return ret


# XMLեκɹ: XML  DOMĥ꡼
  def reloadXML(self, in_name):
    self.infilename = in_name
    self.dom = parse(self.infilename)
    self.the_root_node = self.dom
    self.cur_node = self.the_root_node
#    self.node_list = []
#    self.tmp_node_list = []

# XMLեɹ: XML  DOMĥ꡼
  def __init__(self, in_name, out_name=None) :
    self.infilename = in_name
    self.outfilename = out_name

    validator = dtdValidator.DtdValidator()
    self.errs = validator.parse(in_name)
    if len(self.errs) > 0:
      print "Parsing error:"
      oldSysid = ""
      message = ""
      for (sysid, line, col, msg) in self.errs:
        if oldSysid != sysid:
          message = sysid + "\n"
          message = message + "line " + str(line) + ": " + msg + "\n"
          oldSysid = sysid
      print message
#    else:
#      print "Parsing ", in_name, "...ok"

    self.dom = parse(self.infilename)
    self.the_root_node = self.dom
    self.cur_node = self.the_root_node
    self.node_list = []
    self.tmp_node_list = []

#----------------------------------------------------------------------
