// -*- C++ -*-
/*!
 * @file RTCInPort.i
 * @brief swig interface file for RTCInPort
 * @date $Date$
 *
 * Copyright (c) 2004 Noriaki Ando <n-ando@aist.go.jp>
 *          Task-intelligence Research Group,
 *          Intelligent System Research Institute,
 *          National Institute of Industrial Science (AIST), Japan
 *          All rights reserved.
 *
 * $Id$
 */

%module RTCInPort


%{
#include "rtm/idl/RTCInPortSkel.h"
%}


namespace RTM
{
  class InPort
  {
  public:
    void put(const CORBA::Any& data);
    RTM::PortProfile* profile();
    
  protected:
    InPort();
    virtual ~InPort();
  };
};
